#pragma once
#include "KTexture.h"
#include <vector>
#include <SDL_joystick.h>

#include "KInput.h"


namespace KapitanGame {
	class KTile;

	class KGame
	{
	public:
		KGame();
		~KGame();
		KGame(const KGame& other) = delete;
		KGame(KGame&& other) noexcept = delete;
		KGame& operator=(const KGame& other) = delete;
		KGame& operator=(KGame&& other) noexcept = delete;
		int Run(int argc, char* args[]);
	private:
		SDL_Window* Window = nullptr;

		SDL_Renderer* Renderer = nullptr;

		KTexture TileTextures[4];
		KTexture PlayerTexture;
		KTexture PlayerTexture2;
		std::vector<KTile> Tiles;

		int MapHeight = -1;
		int MapWidth = -1;
		KInput Input;

		bool LoadMedia();

		SDL_Texture* LoadTexture(const std::string& path) const;
	};
}


