#pragma once
#include <memory>
#include <unordered_map>

#include "KObject.h"
#include "Utils.h"

namespace KapitanGame
{
	class KPlayerController;

	class KPawn : public KObject
	{
	public:
		KPawn(const KVector2D& position, const KTexture& texture,
			const std::shared_ptr<KPlayerController>& playerController)
			: KObject(position, texture),
			PlayerController(playerController)
		{
		}
		void CollisionDetectionStep(const std::unordered_map<std::pair<int, int>, std::shared_ptr<KObject>, Utils::PairHash>& objects);
		void MovementStep(const float& timeStep);
		void CollisionDetectionWithMapStep(const SDL_FRect& map);
		void AddMovementInput(const KVector2D& input);
	private:
		const std::weak_ptr<KPlayerController> PlayerController;
		KVector2D Velocity{ 0.f, 0.f };
	};
}

