#include "KObject.h"

#include <SDL_render.h>

#include "KCamera.h"

namespace KapitanGame
{
	std::atomic<int> KObject::IdCounter{ 0 };

	KObject::KObject(const KVector2D& position, const KTexture& texture) :
		Id(++IdCounter), Position(position), Texture(texture)
	{
	}

	void KObject::Render(SDL_Renderer* renderer, const KCamera& camera) const
	{
		Texture.Render(renderer, Position.X - Texture.GetWidth() / 2.f - camera.GetViewport().x, Position.Y - Texture.GetHeight() / 2.f - camera.GetViewport().y, nullptr, camera.GetScale());  // NOLINT(clang-diagnostic-implicit-int-float-conversion, bugprone-narrowing-conversions, cppcoreguidelines-narrowing-conversions)
	}

	KVector2D KObject::GetPosition() const
	{
		return Position;
	}
}
