#include "KCollider.h"

namespace KapitanGame {
	KCollider::KCollider(const KCollider& other) = default;

	KCollider::KCollider(KCollider&& other) noexcept: Parent(other.Parent)
	{
	}

	KCollider& KCollider::operator=(const KCollider& other)
	{
		if (this == &other)
			return *this;
		Parent = other.Parent;
		return *this;
	}

	KCollider& KCollider::operator=(KCollider&& other) noexcept
	{
		if (this == &other)
			return *this;
		Parent = other.Parent;
		return *this;
	}

	KCollider::KCollider(KSolid* parent): Parent(parent)
	{
	}

	KSolid* KCollider::GetParent() const
	{
		return Parent;
	}
}
